/*
Este es un ejemplo que usa la funcin de base de datos de winsock gethosbyaddr que obtiene
el nombre del dominio y direccin IP correspondiente a una direccin de red.
Esta funcion es necesaria para toda aplicacin que corre en internet para que una vez ingresado el dominio
al cual el cliente se quiere conectar realiza un consulta DNS para determinar cual es la IP al cual debe 
conectarse. 
Funciona en modo consola bajo W95, programado en VC++

como funciona?
- conectarse a internet
- abrir una ventana MSDOS
- ejecutar el programa con el parmetre. ejemplo gesthosbyaddres 200.2.2.1

aspectos a tener en cuenta:
	* incluir el archivo de cabecera winsock.h
	* en el coplilador enlazar con la libreria de winsock, usualmente llamado wsock32.lib o winsock32.lib.
	  en este caso esta enlazado de la siguiente forma: en project setting object/library modules incluir el 
	  archivo ws2_32.lib y en tool options solapa directories se debe agregar em include file el directorio 
	  donde esta el archivo winsock.h y en library file el directorio donde esta el archivo ws2_32.lib.    
	* para disponer de la libreuira socket, en antes de comenzar a trabajar; se debe llamar a:
		WSADATA wsaData;

	if (WSAStartup(MAKEWORD(1, 1), &wsaData) !=0){
		cerr << "WSAStartup fallo";
		return 1;
	}
	* WSAStarup. se debe llamar a esta funcion antes de llamr a cualquiera otra de winsock. nos permite
	  especificar que version de la API de windos socket va a necesitar nuestro programa. se establece una 
	  negocicin entre la aplicacin y Winsock.dll
	* WSCleanup() termina sesion desde los DLL subycentes de winsock

Comentarios: tamburi@southlink.com.ar
*/

#include <winsock.h>
#include <iostream.h>
#include <stdio.h>
#include <stdarg.h>

hostent *p;
char *alias;
int i;
IN_ADDR add;
long int ip;
char dire[15];


int main(int argc, char *argv[])

{
	if(argc!=2)
	{
		strerror(errno);
		cout << "error debe pasar una direccion IP!!";
		return 1;
	}
	
	
	WSADATA wsaData;

	if (WSAStartup(MAKEWORD(1, 1), &wsaData) !=0){
		cerr << "WSAStartup fallo";
		return 1;
	}
	
	
	ip=inet_addr(argv[1]);
	
	add.S_un.S_addr = ip;
	
	p=gethostbyaddr((char *)&add.S_un.S_addr, sizeof(add.S_un.S_addr), AF_INET);
		
	if (p==NULL)
	{
		strerror(errno);
		cerr << "error en gethostbyaddr()" << endl;
		return 1;
	}
	else
	{
		cout << "nombre del host :" << p->h_name << endl;
		
		memcpy(&add.S_un,p->h_addr_list[0],p->h_length);
		
		cout << "direccin IP :" << inet_ntoa(add) << endl; 
		
		cout << "tipo de direccion: " << p->h_addrtype << endl;
		
		cout << "longuitud de la direccion en byte :" << p->h_length << endl;
		
		if(p->h_aliases[0]!=NULL)
		{
			cout << "alias :" << p->h_aliases[0] << endl;
		}
		
		
		cout << "direcciones IP :" << endl;
		i=0;
		while(p->h_addr_list[i])
		{
			memcpy(&add.S_un,p->h_addr_list[i],p->h_length);
			cout << "direccion IP :" << inet_ntoa(add) << endl;
			i++;
			
		}

	}
	system("pause");
	WSACleanup();
	return 0;
}

